; An example of a simple combo box (style=CBS_SIMPLE) with the edit box portion subclassed so that
;   the user can type in his own selection and hit return to accept it, or hit escape to abort.

.686p
.model  flat, stdcall
option  casemap :none   ; case sensitive
.nolist
include windows.inc

uselib  MACRO   libname
    include     libname.inc
    includelib  libname.lib
ENDM

uselib user32
uselib kernel32
uselib comctl32

.listall
inv equ invoke

DlgProc     PROTO :DWORD,:DWORD,:DWORD,:DWORD

cb equ 1041     ; id of combobox

.data?
hInst dd ?
hWin  dd ?
hcb   dd ?      ; handle of combobox

buff  db 100 dup (?)    ; scratch
.data
started dd 0

.code
Program:
    invoke  GetModuleHandle, NULL
    mov hInst,eax
    invoke  InitCommonControls
    invoke  DialogBoxParam, hInst, 101, 0, ADDR DlgProc, 0
    invoke  ExitProcess, eax

DlgProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    .if uMsg == WM_INITDIALOG
        mov eax,hWnd    ; save our handle
        mov hWin,eax
        inv ShowWindow,hWin,SW_SHOW
        invoke GetDlgItem,hWin,cb
        mov hcb,eax         ; save handle to control
        call SetupResize
    .elseif uMsg==WM_SIZE
        call Resize     
    .elseif uMsg == WM_CLOSE
        invoke  EndDialog,hWin,0
    .endif

    xor eax,eax
    ret
DlgProc endp

.data?
WinRect   RECT <?>  ; left,top,right,bottom of Dialog window
CbRect    RECT <?>  ; delta combo to Dialog window
CbLeft        dd ?  ; actual combo left relative to Dialog
CbTop         dd ?  ; actual combo top relative to Dialog
CbDialogWidthDelta  dd ? ; Delta for computing new combo and Edit control Width
CbDialogHeightDelta dd ? ; Delta for computing new combo Height
.code

Resize proc
    mov eax,started
    cmp eax,1
    jne ResizeRet
    inv GetWindowRect,hWin,addr WinRect

    mov eax,WinRect.right
    sub eax,WinRect.left        ;width of dialog
    sub eax,CbDialogWidthDelta  ;new width of combo
    mov edx,WinRect.bottom
    sub edx,WinRect.top         ;height of dialog
    sub edx,CbDialogHeightDelta ;new height of combo
    inv MoveWindow,hcb,CbLeft,CbTop,eax,edx,TRUE

ResizeRet:
    ret
Resize EndP

SetupResize proc
    ; save position of combo Cb relative to Dialog for resizing event
    inv GetWindowRect,hWin,ADDR WinRect ; get window position
    inv GetWindowRect,hcb,ADDR CbRect   ; get starting position of combo

    mov edx,CbRect.right
    sub edx,CbRect.left
    mov eax,WinRect.right
    sub eax,WinRect.left
    sub eax,edx
    mov CbDialogWidthDelta,eax

    mov eax,WinRect.bottom
    sub eax,WinRect.top
    mov edx,CbRect.bottom
    sub edx,CbRect.top
    sub eax,edx
    mov CbDialogHeightDelta,eax
    
    mov eax,CbRect.left
    sub eax,WinRect.left
    sub eax,3
    mov CbLeft,eax
    mov eax,CbRect.top
    sub eax,WinRect.top
    sub eax,23
    mov CbTop,eax
    mov started,1
    ret
SetupResize EndP

end Program